#include <iostream>
#include <math.h>
#include <stdio.h>
#include <algorithm>
using namespace std;

int main(int argc, char** argv) {
	int t;
	cin>>t;
	int a[t];
	for(int j=0;j<t;j++){
		a[j]=1;
		int m,n,k=0;
		scanf("%d %d",&m,&n);
		long long x[m],y[n],razl=0,zb;
	
		for(int i=0;i<m;i++){
			scanf("%lld",&x[i]);
		}
		for(int i=0;i<n;i++){
			scanf("%lld",&y[i]);
		}
		zb=x[0];
		sort(x , x+m);
		sort(y , y+n);
		razl=x[1]-x[0];
		while(k<=n){
		
		if(zb!=y[k]){
			if(zb>y[k])k++;
		}else{
			a[j]=0;
			break;
		}
		zb+=razl;	
		}
		
	}
	for(int i=0;i<t;i++){
		printf("%d\n",a[i]);
	}
	return 0;
}